---
import UnloggedLayout from "@/shared/layouts/UnloggedLayout.astro";
import { getProduct } from "@/products/services/ProductsService";
import AddCartSvg from "@/shared/svgs/AddCartSvg.astro";
import ArrowSvg from "@/shared/svgs/ArrowSvg.astro";
import { formatPrice } from "@/shared/utils/format-price";
import { Image } from "astro:assets";

const { id } = Astro.params;

const { product } = await getProduct(Number(id));
---

<UnloggedLayout title="Product Detail">
  <section class="flex items-center justify-center py-4 px-6 h-full w-full">
    <article
      class="bg-neutral-700 flex items-center border border-4 border-neutral-600 rounded-md py-8 px-4 relative w-[1000px]"
    >
      <div class="flex items-center w-[500px]">
        <div class="flex flex-col items-center justify-evenly w-1/4 h-full">
          {
            product.images.map((image, idx) => (
              <button
                type="button"
                class="hover:opacity-70 disabled:opacity-50"
                disabled={idx === 0}
                onclick="selectImage(this)"
              >
                <Image
                  src={`/api/v1/images?url=${image}`}
                  class="w-[80px] h-[80px] my-4 rounded-md aspect-square"
                  width={60}
                  height={60}
                  alt={`${idx}`}
                  loading="eager"
                />
              </button>
            ))
          }
        </div>
        <Image
          src={`/api/v1/images?url=${product.images[0]}`}
          class="thumbnail-product w-[350px] h-[350px] rounded-md aspect-square"
          width={350}
          height={350}
          alt={`${product.title} thumbnail`}
          loading="eager"
        />
      </div>
      <div class="flex flex-col py-8 px-2 w-[500px]">
        <h2 class="font-bold text-3xl">{product.title}</h2>
        <span class="bg-neutral-950 my-6 py-2 px-4 rounded font-bold w-fit">
          {product.category.name}
        </span>
        <p class="text-neutral-300 w-3/4">
          {product.description}
        </p>
        <div class="flex items-center justify-between mt-4 w-full">
          <div class="flex flex-col text-2xl font-bold">
            <span class="text-neutral-300 text-lg font-normal">Price:</span>
            {formatPrice(product.price)}
          </div>
          <button
            type="button"
            class="bg-violet-800 hover:bg-violet-900 py-2 px-4 font-bold rounded-md"
          >
            <AddCartSvg size={28} />
          </button>
        </div>
      </div>
      <button
        type="button"
        class={`
          bg-neutral-800 flex items-center absolute top-2 text-sm
          right-4 rounded-full text-neutral-200 pl-2 pr-4 py-2 hover:opacity-80
        `}
        onclick="backPage()"
      >
        <div class="rotate-90 mr-1">
          <ArrowSvg />
        </div>
        Back
      </button>
    </article>
  </section>
</UnloggedLayout>

<style></style>

<script is:inline>
  const thubmnailMain = document.querySelector(".thumbnail-product");

  function backPage() {
    window.history.back();
  }

  function selectImage(imgContainer) {
    const btnsContainer = imgContainer.parentNode;
    const allButtons = btnsContainer.querySelectorAll("button");
    allButtons.forEach((btn) => (btn.disabled = false));
    imgContainer.disabled = true;
    const img = Array.from(imgContainer.childNodes).find((element) => element.nodeName === "IMG");
    thubmnailMain.src = img.src;
  }
</script>
